import React__default from 'react';
import Breadcrumbs from '@mui/material/Breadcrumbs';
import Typography from '@mui/material/Typography';
import Link from '@mui/material/Link';
import Stack from '@mui/material/Stack';
import { SectionHeaderWrapper } from './style.js';
import PaginationIcon from '../../Icons/PaginationIcon/index.js';
import { SectionHeaderHeadingWrapper, SectionHeaderSubHeadingWrapper } from '../../Typography/Paragraph/index.js';
import theme from '../../../Globals/theme.js';
import { ThemeProvider } from 'styled-components';
import globalStyle from '../../../Globals/global-styles.js';

var SectionHeader = function SectionHeader(_ref) {
  var link = _ref.link,
      from = _ref.from,
      to = _ref.to,
      sectionName = _ref.sectionName,
      subHeading = _ref.subHeading;
  var breadcrumbs = [/*#__PURE__*/React__default.createElement(Link, {
    underline: "none",
    key: "1",
    href: link
  }, from), /*#__PURE__*/React__default.createElement(Typography, {
    underline: "none",
    key: "2",
    "aria-current": "page"
  }, to)];
  return /*#__PURE__*/React__default.createElement(ThemeProvider, {
    theme: theme
  }, /*#__PURE__*/React__default.createElement(globalStyle, null), /*#__PURE__*/React__default.createElement(React__default.Fragment, null, /*#__PURE__*/React__default.createElement(SectionHeaderWrapper, null, /*#__PURE__*/React__default.createElement(Stack, {
    spacing: 2
  }, /*#__PURE__*/React__default.createElement(Breadcrumbs, {
    separator: /*#__PURE__*/React__default.createElement(PaginationIcon, null),
    "aria-label": "breadcrumb"
  }, breadcrumbs)), /*#__PURE__*/React__default.createElement(SectionHeaderHeadingWrapper, null, sectionName), /*#__PURE__*/React__default.createElement(SectionHeaderSubHeadingWrapper, null, subHeading))));
};

export { SectionHeader as default };
//# sourceMappingURL=index.js.map
