import React__default from 'react';
import { TableItemWrapper } from './style.js';
import { ThemeProvider } from 'styled-components';
import theme from '../../../Globals/theme.js';
import globalStyle from '../../../Globals/global-styles.js';

var TableItem = function TableItem(props) {
  var icon = props.icon,
      children = props.children,
      isLabel = props.isLabel,
      onClick = props.onClick,
      labelSize = props.labelSize;

  var handleClassname = function handleClassname() {
    if (isLabel && onClick) {
      return "labeled cursor";
    } else if (onClick) {
      return "cursor";
    } else if (isLabel) {
      return "labeled";
    } else {
      return "";
    }
  };

  var className = handleClassname();
  return /*#__PURE__*/React__default.createElement(ThemeProvider, {
    theme: theme
  }, /*#__PURE__*/React__default.createElement(globalStyle, null), /*#__PURE__*/React__default.createElement(TableItemWrapper, {
    onClick: onClick,
    className: className,
    labelSize: labelSize
  }, icon, children));
};

export { TableItem as default };
//# sourceMappingURL=index.js.map
